﻿using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Data;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Events;
using Infragistics.UltraChart.Core.Layers;
using System.Collections;
using Infragistics.Win.UltraWinToolTip;

namespace WC_GanttChartSplitter
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
			ultraChart1.DataItemOver += new DataItemOverEventHandler(ultraChart1_DataItemOver);
			ultraChart1.DataItemOut += new DataItemOutEventHandler(ultraChart1_DataItemOut);
		}

		void ultraChart1_DataItemOut(object sender, ChartDataEventArgs e)
		{
			var toolTipInfo = ultraToolTipManager1.GetUltraToolTip(ultraChart1);
			toolTipInfo.ToolTipText = "";
			ultraToolTipManager1.HideToolTip();
		}

		void ultraChart1_DataItemOver(object sender, ChartDataEventArgs e)
		{
			if (e.Primitive is Text)
			{
				var text = e.Primitive as Text;
				if (text.bounds.X == 46)
				{
					var toolTipInfo = ultraToolTipManager1.GetUltraToolTip(ultraChart1);
					toolTipInfo.ToolTipText = text.GetTextString();
					ultraToolTipManager1.ShowToolTip(ultraChart1);
				}
			}
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.GanttChart;

			GanttDataSource ganttData = new GanttDataSource();

			GanttSeries seriesA = ganttData.Series.Add("Series A");
			GanttItem task1 = seriesA.Items.Add("Task 1");
			task1.Times.Add(DateTime.Now, DateTime.Now.AddDays(5));
			task1.Times[0].ID = 0;
			task1.Times[0].LinkToID = 1;
			task1.Times[0].PercentComplete = 50;
			task1.Times[0].Owner = "Worker A";
			GanttItem task2 = seriesA.Items.Add("Task 2");
			task2.Times.Add(DateTime.Now.AddDays(2),
			  DateTime.Now.AddDays(4));
			task2.Times[0].ID = 0;
			task2.Times[0].LinkToID = -1;
			task2.Times[0].PercentComplete = 100;
			task2.Times[0].Owner = "Worker A";

			ultraChart1.DataSource = ganttData;

			ultraChart1.Axis.Y.LineThickness = 2;
			this.ultraChart1.FillSceneGraph += new Infragistics.UltraChart.Shared.Events.FillSceneGraphEventHandler(this.ChartFillSceneGraph_Event);

			MovingAxisTool movingAxisTool = new MovingAxisTool(this.ultraChart1);
			ultraChart1.AddMouseDownTool(movingAxisTool);
		}

		private void ultraChart1_MouseHover(object sender, EventArgs e)
		{

		}

		private void ultraChart1_MouseDown(object sender, MouseEventArgs e)
		{

		}

		private void ChartFillSceneGraph_Event(object sender, FillSceneGraphEventArgs e)
		{
			foreach (var p in e.SceneGraph)
			{
				var label = p as Text;
				if (label != null)
				{
					label.Caps = PCaps.HitTest | PCaps.Tooltip;
					label.Row = label.Column = 0;
				}
			}
		}
	}
}
